import pygame
import sys
from pygame.locals import *
import RPi.GPIO as GPIO
import urllib.request
from datetime import datetime
import json
from random import randint
from pprint import pprint
import time
import pickle
import collections
import os
from operator import itemgetter, attrgetter, methodcaller

#variables del juego
jugando = True
seguirEnBucle = True
time_stamp_btn = time.time()
btnPulsado = -1
strNombre = ''

sound_inicio = "/home/pi/QuizzPi/inicio.mp3"
sound_acierto = "/home/pi/QuizzPi/aplauso.mp3" 
sound_error = "/home/pi/QuizzPi/error.mp3"
sound_antesde = "/home/pi/QuizzPi/antesdetada.mp3"
sound_resultados = "/home/pi/QuizzPi/tada.mp3"
sound_beep = "/home/pi/QuizzPi/beep.mp3"



#fases del juego
f_INICIO = 0
f_MENU = 1
f_IDENTIFICACION = 2
f_PREGUNTAS = 3
f_RESULTADOS = 4
f_MEJORES = 5
f_INFORMACION = 6

fase_actual = f_INICIO

# Definimos los botones
btnRojo = 31 		# boton ROJO
btnAmarillo = 33 	# boton AMARILLO
btnVerde = 35 		# boton VERDE
btnAzul = 37 		# boton AZUL
 
# Definimos algunos colores
cBLANCO   = (255, 255, 255)
cNEGRO    = (  0,   0,   0)
cNARANJA  = (255, 138,   0)
cROJO     = (255,   0,   0)
cAMARILLO = (255, 191,   0)
cVERDE    = ( 72, 183,   5)
cAZUL     = (  0,   0, 255) 

# Inicializamos los GPIO
GPIO.setmode(GPIO.BOARD)
GPIO.setup(btnRojo, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(btnAmarillo, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(btnVerde, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(btnAzul, GPIO.IN, pull_up_down=GPIO.PUD_UP)

#os.putenv ("SDL_FBDEV" , "/dev/fb1")
#os.putenv ("SDL_MOUSEDRV" , "TSLIB")
#os.putenv ("SDL_MOUSEDEV" , "/dev/input/event0")

# Definimos las funciones de los botones
def btnPush(channel):
	global time_stamp_btn
	global btnPulsado
	time_now = time.time()
	if (time_now - time_stamp_btn >= 0.3):
			btnPulsado = channel
	time_stamp_btn = time_now

# Asociamos un evento a los botones
# Example: GPIO.add_event_detect(BUTTON_1, GPIO.BOTH, bouncetime=1000)
GPIO.add_event_detect(btnRojo, GPIO.BOTH, callback=btnPush)
GPIO.add_event_detect(btnAmarillo, GPIO.BOTH, callback=btnPush)
GPIO.add_event_detect(btnVerde, GPIO.BOTH, callback=btnPush)
GPIO.add_event_detect(btnAzul, GPIO.BOTH, callback=btnPush)

#Inicializamos pygame
pygame.mixer.pre_init(44100, -16, 1, 1024*3) #PreInit Music, plays faster
pygame.init()

# initialize font; must be called after 'pygame.init()' to avoid 'Font not Initialized' error
myfont = pygame.font.SysFont("monospace", 15)

# Ocultamos el puntero del raton
pygame.mouse.set_visible(False) #hide the mouse cursor
  
# Establecemos el largo y ancho de la pantalla.
dimensiones = [480,320]
pantalla = pygame.display.set_mode(dimensiones, pygame.FULLSCREEN)
posicion_base = [0,0]
 
# Usado para gestionar cuán rápido se actualiza la pantalla
reloj = pygame.time.Clock()
 
def generaPreguntaSumas1Cifra():
	arg1 = randint(0, 9)
	arg2 = randint(0, 9)
	arg3 = randint(1, 2)
	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cuanto es la suma de ' + str(arg1) + ' mas ' + str(arg2) +'?", "correct_answer": "' + str(arg1+arg2) + r'", "incorrect_answers": ["' + str(arg1+arg2+arg3) + r'", "' + str(arg1+arg2-arg3) + r'", "' + str(arg1+arg2+arg3+1) + r'"]}'
	return pregunta;

def generaPreguntaSumas2Cifras():
	arg1 = randint(0, 80)
	arg2 = randint(0, 99)
	arg3 = randint(1, 20)
	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cuanto es la suma de ' + str(arg1) + ' mas ' + str(arg2) +'?", "correct_answer": "' + str(arg1+arg2) + r'", "incorrect_answers": ["' + str(arg1+arg2+arg3) + r'", "' + str(arg1+arg2-arg3) + r'", "' + str(arg1+arg2+arg3+1) + r'"]}'
	return pregunta;

def generaPreguntaSumas2CifrasFacil():
	arg1u = randint(0, 9)
	arg1d = randint(0, 9)
	arg2u = randint(0, 9)
	arg2d = randint(0, 9)
	arg3 = randint(1, 20)
	while (arg2u+arg1u>9):
		arg2u = randint(0, 9)
	while (arg2d+arg1d>9):
		arg2d = randint(0, 9)
	arg1 = arg1d*10 + arg1u
	arg2 = arg2d*10 + arg2u
	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cuanto es la suma de ' + str(arg1) + ' mas ' + str(arg2) +'?", "correct_answer": "' + str(arg1+arg2) + r'", "incorrect_answers": ["' + str(arg1+arg2+arg3) + r'", "' + str(arg1+arg2-arg3) + r'", "' + str(arg1+arg2+arg3+1) + r'"]}'
	return pregunta;

def generaPreguntaMayorQue():
	arg1 = randint(0, 95)
	bueno = arg1 + randint(1,100-arg1)
	malo1 = arg1 - randint(0, arg1)
	malo2 = arg1 - randint(0, arg1)
	malo3 = arg1 - randint(0, arg1)
	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cual de estos números es MAYOR que ' + str(arg1) +'?", "correct_answer": "' + str(bueno) + r'", "incorrect_answers": ["' + str(malo1) + r'", "' + str(malo2) + r'", "' + str(malo3) + r'"]}'
	return pregunta;

def generaPreguntaMenorQue():
	arg1 = randint(0, 95)
	bueno = arg1 - randint(1,arg1)
	malo1 = arg1 + randint(0, 100-arg1)
	malo2 = arg1 + randint(0, 100-arg1)
	malo3 = arg1 + randint(0, 100-arg1)
	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cual de estos números es MENOR que ' + str(arg1) +'?", "correct_answer": "' + str(bueno) + r'", "incorrect_answers": ["' + str(malo1) + r'", "' + str(malo2) + r'", "' + str(malo3) + r'"]}'
	return pregunta;

def generaPreguntaSerie():
	buena = []
	buena.append(randint(0, 99))
	valor = randint(0, 99)
	while (valor in buena):
		valor = randint(0, 99)
	buena.append(valor)
	valor = randint(0, 99)
	while (valor in buena):
		valor = randint(0, 99)
	buena.append(valor)
	buena.sort()
	strBuena = str(buena[0]) + ' < ' + str(buena[1]) + ' < '  + str(buena[2])

	malas = []
	iMalas = 0
	while (iMalas<3):
		mala = []
		mala.append(randint(0, 99))
		valor = randint(0, mala[0])
		while (valor in mala):
			valor = randint(0, mala[0])
		mala.append(valor)
		valor = randint(mala[1], 99)
		while (valor in mala):
			valor = randint(mala[1], 99)
		mala.append(valor)
		strMala = str(mala[0]) + ' < ' + str(mala[1]) + ' < '  + str(mala[2])
		malas.append(strMala)
		iMalas = iMalas + 1

	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cual de estas series es correcta?", "correct_answer": "' + strBuena + r'", "incorrect_answers": ["' + malas[0] + r'", "' + malas[1] + r'", "' + malas[2] + r'"]}'
	return pregunta;

def generaPreguntaAnteriorA():
	arg1 = randint(5, 99)
	bueno = arg1 - 1
	malo1 = arg1 - randint(1, 10)
	malo2 = arg1 - randint(1, 10)
	while (malo2 == malo1):
		malo2 = arg1 - randint(1, 10)
	malo3 = arg1 - randint(1, 10)
	while ((malo3 == malo1) or (malo3 == malo2)):
		malo3 = arg1 - randint(1, 10)
	pregunta = r'{"category": "1 de Primaria", "type": "multiple", "difficulty": "easy", "question": "¿Cual de estos números es el ANTERIOR a ' + str(arg1) +'?", "correct_answer": "' + str(bueno) + r'", "incorrect_answers": ["' + str(malo1) + r'", "' + str(malo2) + r'", "' + str(malo3) + r'"]}'
	return pregunta;

def generaPreguntasPrimaria():
	preguntas = r'{"response_code": 0,"results": ['
	pr = 0
	while (pr<10):
		categoria = randint(0,5)
		if (categoria == 0):
			preguntas = preguntas + generaPreguntaSumas1Cifra()
		if (categoria == 1):
			preguntas = preguntas + generaPreguntaSumas2CifrasFacil()
		if (categoria == 2):
			preguntas = preguntas + generaPreguntaMayorQue()
		if (categoria == 3):
			preguntas = preguntas + generaPreguntaMenorQue()
		if (categoria == 4):
			preguntas = preguntas + generaPreguntaSerie()
		if (categoria == 5):
			preguntas = preguntas + generaPreguntaAnteriorA()
		pr = pr + 1
		if (pr < 10):
			preguntas = preguntas + ','
	preguntas = preguntas + ']}'
	return preguntas

def dameLetra (pos):
	print("dentro de dameletra. Pos=("+str(pos[0])+","+str(pos[1])+")")
	letra = ''
	if 24 <= pos[0] <= 57 and 117 <= pos[1] <= 157:			# A
		letra = 'A'
	elif 74 <= pos[0] <= 107 and 117 <= pos[1] <= 157:		# B
		letra = 'B'
	elif 124 <= pos[0] <= 157 and 117 <= pos[1] <= 157:		# C
		letra = 'C'
	elif 174 <= pos[0] <= 207 and 117 <= pos[1] <= 157:		# D
		letra = 'D'
	elif 224 <= pos[0] <= 257 and 117 <= pos[1] <= 157:		# E
		letra = 'E'
	elif 274 <= pos[0] <= 307 and 117 <= pos[1] <= 157:		# F
		letra = 'F'
	elif 324 <= pos[0] <= 357 and 117 <= pos[1] <= 157:		# G
		letra = 'G'
	elif 374 <= pos[0] <= 407 and 117 <= pos[1] <= 157:		# H
		letra = 'H'
	elif 424 <= pos[0] <= 457 and 117 <= pos[1] <= 157:		# I
		letra = 'I'
	elif 24 <= pos[0] <= 57 and 167 <= pos[1] <= 207:		# J
		letra = 'J'
	elif 74 <= pos[0] <= 107 and 167 <= pos[1] <= 207:		# K
		letra = 'K'
	elif 124 <= pos[0] <= 157 and 167 <= pos[1] <= 207:		# L
		letra = 'L'
	elif 174 <= pos[0] <= 207 and 167 <= pos[1] <= 207:		# M
		letra = 'M'
	elif 224 <= pos[0] <= 257 and 167 <= pos[1] <= 207:		# N
		letra = 'N'
	elif 274 <= pos[0] <= 307 and 167 <= pos[1] <= 207:		# Ñ
		letra = 'Ñ'
	elif 324 <= pos[0] <= 357 and 167 <= pos[1] <= 207:		# O
		letra = 'O'
	elif 374 <= pos[0] <= 407 and 167 <= pos[1] <= 207:		# P
		letra = 'P'
	elif 424 <= pos[0] <= 457 and 167 <= pos[1] <= 207:		# Q
		letra = 'Q'
	elif 24 <= pos[0] <= 57 and 217 <= pos[1] <= 257:		# R
		letra = 'J'
	elif 74 <= pos[0] <= 107 and 217 <= pos[1] <= 257:		# S
		letra = 'K'
	elif 124 <= pos[0] <= 157 and 217 <= pos[1] <= 257:		# T
		letra = 'L'
	elif 174 <= pos[0] <= 207 and 217 <= pos[1] <= 257:		# U
		letra = 'M'
	elif 224 <= pos[0] <= 257 and 217 <= pos[1] <= 257:		# V
		letra = 'N'
	elif 274 <= pos[0] <= 307 and 217 <= pos[1] <= 257:		# W
		letra = 'Ñ'
	elif 324 <= pos[0] <= 357 and 217 <= pos[1] <= 257:		# X
		letra = 'O'
	elif 374 <= pos[0] <= 407 and 217 <= pos[1] <= 257:		# Y
		letra = 'P'
	elif 424 <= pos[0] <= 457 and 217 <= pos[1] <= 257:		# Z
		letra = 'Q'
	
	print("letra="+letra)
	return letra

while (jugando == True):
	# -------- Bucle de la PANTALLA INICIAL -----------
	if ((jugando == True) and (fase_actual == f_INICIO)):
		# Limpia la pantalla y establece su color de fondo
		pantalla.fill(cBLANCO)
	
		# Muestra la pantalla inicial en pantalla:
		imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_0_INICIO_ingles.png").convert()
		pantalla.blit(imagen, posicion_base)

		# Limitamos a 20 fotogramas por segundo.
		reloj.tick(20)
 
		# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
		pygame.display.flip()

		pygame.mixer.music.load(sound_inicio)
		pygame.mixer.music.play(0)
	
		# Esperamos pulsacion de boton
		btnPulsado = -1
		seguirEnBucle = True
		while (seguirEnBucle):
			if (btnPulsado == btnAzul):			# El usuario pulsa el BOTON AZUL pasamos al menu
				btnPulsado = -1
				jugando = False
				seguirEnBucle = False
			if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO pasamos al menu
				btnPulsado = -1
				seguirEnBucle = False
				fase_actual = f_MENU
				
	# -------- Bucle del MENU -----------
	if (jugando and (fase_actual == f_MENU)):
		# Limpia la pantalla y establece su color de fondo
		pantalla.fill(cBLANCO)
 
		# Muestra la pantalla inicial en pantalla:
		imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_1_MENU_ingles.png").convert()
		pantalla.blit(imagen, posicion_base)

		# Limitamos a 60 fotogramas por segundo.
		reloj.tick(20)
 
		# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
		pygame.display.flip()

		pygame.mixer.music.load(sound_beep)
		pygame.mixer.music.play(0)
	
		# Esperamos pulsacion de boton
		btnPulsado = -1
		seguirEnBucle = True
		while (seguirEnBucle):
			if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO pasamos a IDENTIFICACION
				btnPulsado = -1
				fase_actual = f_IDENTIFICACION
				seguirEnBucle = False
			if (btnPulsado == btnAmarillo):			# El usuario pulsa el BOTON AMARILLO pasamos a los MEJORES
				btnPulsado = -1
				fase_actual = f_MEJORES
				seguirEnBucle = False
			if (btnPulsado == btnVerde):			# El usuario pulsa el BOTON VERDE pasamos a la INFO
				btnPulsado = -1
				fase_actual = f_INFORMACION
				seguirEnBucle = False
			if (btnPulsado == btnAzul):			# El usuario pulsa el BOTON AZUL salimos al INICIO
				btnPulsado = -1
				fase_actual = f_INICIO
				seguirEnBucle = False
		
	# -------- Bucle de la Pantalla de INFORMACION -----------
	if (jugando and (fase_actual == f_INFORMACION)):
		# Limpia la pantalla y establece su color de fondo
		pantalla.fill(cBLANCO)
 
		# Muestra la pantalla inicial en pantalla:
		imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_4_INFORMACION_ingles.png").convert()
		pantalla.blit(imagen, posicion_base)

		# Limitamos a 60 fotogramas por segundo.
		reloj.tick(20)
 
		# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
		pygame.display.flip()

		pygame.mixer.music.load(sound_beep)
		pygame.mixer.music.play(0)
	
		# Esperamos pulsacion de boton
		btnPulsado = -1
		seguirEnBucle = True
		while (seguirEnBucle):
			if (btnPulsado == btnRojo):				# El usuario pulsa el BOTON ROJO volvemos al MENU
				btnPulsado = -1
				fase_actual = f_MENU
				seguirEnBucle = False
		
	# -------- Bucle de la Pantalla de MEJORES -----------
	if (jugando and (fase_actual == f_MEJORES)):
		# Limpia la pantalla y establece su color de fondo
		pantalla.fill(cBLANCO)
 
		# Muestra la pantalla inicial en pantalla:
		imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_5_MEJORES_ingles.png").convert()
		pantalla.blit(imagen, posicion_base)

		# Recuperamos el fichero de mejores
		high_scores = {}
		if (os.path.exists('/home/pi/QuizzPi/losmejores.txt')) and (os.path.getsize('/home/pi/QuizzPi/losmejores.txt')>0):
			high_scores = json.load(open('/home/pi/QuizzPi/losmejores.txt'))
		else:
			high_scores = {}

		# Iteramos para mostrar
		i = 1
		for key, scores in high_scores.items():
			for tupla in sorted(sorted(sorted(scores, key=itemgetter(3), reverse=False), key=itemgetter(2), reverse=True), key=itemgetter(4), reverse=True):
				nombre = tupla[0]
				nota = tupla[1]
				tiempo = tupla[3]
				porcentaje = tupla[4]
				fuente = pygame.font.SysFont('arial', 22)
				mensaje = fuente.render(str(i), 1, cROJO)
				pantalla.blit(mensaje, (40-mensaje.get_rect().width/2, 52+i*18))
				fuente = pygame.font.SysFont('arial', 22)
				mensaje = fuente.render(nombre, 1, cAZUL)
				pantalla.blit(mensaje, (60, 52+i*18))
				mensaje = fuente.render(str(nota), 1, cAZUL)
				pantalla.blit(mensaje, (300-mensaje.get_rect().width/2, 52+i*18))
				mensaje = fuente.render(str(tiempo), 1, cAZUL)
				pantalla.blit(mensaje, (380-mensaje.get_rect().width/2, 52+i*18))
				i = i + 1

		# Limitamos a 60 fotogramas por segundo.
		reloj.tick(20)
 
		# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
		pygame.display.flip()

		pygame.mixer.music.load(sound_acierto)
		pygame.mixer.music.play(0)
	
		# Esperamos pulsacion de boton
		btnPulsado = -1
		seguirEnBucle = True
		while (seguirEnBucle):
			if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO volvemos al MENU
				btnPulsado = -1
				fase_actual = f_MENU
				seguirEnBucle = False

	# -------- Bucle de IDENTIFICACION -----------
	if (jugando and (fase_actual == f_IDENTIFICACION)):
		# Limpia la pantalla y establece su color de fondo
		pantalla.fill(cBLANCO)
 
		# Muestra la pantalla inicial en pantalla:
		imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_21_NOMBRE_ingles.png").convert()
		pantalla.blit(imagen, posicion_base)

		fuente = pygame.font.SysFont('arial', 64)
		mensaje = fuente.render('A', 1, cAZUL)
		pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 130))

		# Limitamos a 60 fotogramas por segundo.
		reloj.tick(20)
 
		# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
		pygame.display.flip()

		pygame.mixer.music.load(sound_beep)
		pygame.mixer.music.play(0)
	
		# Esperamos pulsacion de boton
		btnPulsado = -1
		seguirEnBucle = True
		aLetras = ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','Ñ','O','P','Q','R','S','T','U','V','W','X','Y','Z','«']
		iLetra = 0
		strNombre = ''
		while (seguirEnBucle):
			# for event in pygame.event.get():
				# if event.type == pygame.MOUSEBUTTONDOWN:
					# pos = (pygame.mouse.get_pos() [0], pygame.mouse.get_pos() [1])
					# pygame.draw.circle(pantalla, cROJO, pos, 2, 0)
					# print("llamo a dameletra. Pos=("+str(pos[0])+","+str(pos[1])+")")
					# # Comprobamos si hemos pulsado una tecla
					# letra = dameLetra(pos)
					# print("letra="+letra)
					# if (letra != ''):
						# strNombre = strNombre + letra
						# strNombre = "Paco"
						# pygame.draw.rect(pantalla,cBLANCO,(20,66,450,105))
						# mensaje = fuente.render(strNombre, 1, cAZUL)
						# pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 73))
						# pygame.display.flip()

			# if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO pasamos a PREGUNTAS
				# fase_actual = f_PREGUNTAS
				# seguirEnBucle = False
			# if (btnPulsado == btnAmarillo):		# El usuario pulsa el BOTON AMARILLO borramos la ultima letra del nombre
				# if (len(strNombre) > 0):
					# strNombre = strNombre[:-1]
					# #borrar la ultima letra del nombre
					# pygame.draw.rect(pantalla,cBLANCO,(20,66,450,105))
					# mensaje = fuente.render(strNombre, 1, cAZUL)
					# pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 73))
					# pygame.display.flip()
			# if (btnPulsado == btnAzul):			# El usuario pulsa el BOTON AZUL salimos al MENU
				# fase_actual = f_MENU
				# seguirEnBucle = False

			if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO añadimos letra
				btnPulsado = -1
				if iLetra == 27:
					strNombre = strNombre[:-1]
				else:
					if len(strNombre)<15:
						strNombre = strNombre + aLetras[iLetra]
				# Limpia la pantalla y establece su color de fondo
				pantalla.fill(cBLANCO)
 				# Muestra la pantalla inicial en pantalla:
				imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_21_NOMBRE_ingles.png").convert()
				pantalla.blit(imagen, posicion_base)
				fuente = pygame.font.SysFont('arial', 24)
				mensaje = fuente.render(strNombre, 1, cAZUL)
				pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 73))
				fuente = pygame.font.SysFont('arial', 64)
				mensaje = fuente.render(aLetras[iLetra], 1, cAZUL)
				pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 130))
				pygame.display.flip()
				pygame.mixer.music.load(sound_beep)
				pygame.mixer.music.play(0)
			if (btnPulsado == btnAmarillo):		# El usuario pulsa el BOTON AMARILLO pasamos a anterior letra
				btnPulsado = -1
				iLetra = iLetra - 1
				if iLetra < 0:
					iLetra = 27
				# Limpia la pantalla y establece su color de fondo
				pantalla.fill(cBLANCO)
 				# Muestra la pantalla inicial en pantalla:
				imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_21_NOMBRE_ingles.png").convert()
				pantalla.blit(imagen, posicion_base)
				fuente = pygame.font.SysFont('arial', 24)
				mensaje = fuente.render(strNombre, 1, cAZUL)
				pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 73))
				fuente = pygame.font.SysFont('arial', 64)
				mensaje = fuente.render(aLetras[iLetra], 1, cAZUL)
				pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 130))
				pygame.display.flip()
				pygame.mixer.music.load(sound_beep)
				pygame.mixer.music.play(0)
			if (btnPulsado == btnVerde):		# El usuario pulsa el BOTON VERDE pasamos a siguiente letra
				btnPulsado = -1
				iLetra = iLetra + 1
				if iLetra > 27:
					iLetra = 0
				# Limpia la pantalla y establece su color de fondo
				pantalla.fill(cBLANCO)
				imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_21_NOMBRE_ingles.png").convert()
				pantalla.blit(imagen, posicion_base)
				fuente = pygame.font.SysFont('arial', 24)
				mensaje = fuente.render(strNombre, 1, cAZUL)
				pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 73))
				fuente = pygame.font.SysFont('arial', 64)
				mensaje = fuente.render(aLetras[iLetra], 1, cAZUL)
				pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 130))
				pygame.display.flip()
				pygame.mixer.music.load(sound_beep)
				pygame.mixer.music.play(0)
			if (btnPulsado == btnAzul):			# El usuario pulsa el BOTON AZUL continuamos
				fase_actual = f_PREGUNTAS
				seguirEnBucle = False

	# -------- Bucle de PREGUNTAS -----------
	if (jugando and (fase_actual == f_PREGUNTAS)):
		instanteInicial = datetime.now()
		score = 0
		score = int(score)  #Convert the 0 into a number so we can add scores

		NResponse = 10
		nRespuesta = 0
		
		#Cargo desde fichero
		#data = json.load(open('./test.json'))

		#Cargo desde URL
		url = 'https://opentdb.com/api.php?amount=10&category=9&difficulty=easy&type=multiple'
		#url = 'https://opentdb.com/api.php?amount=10&type=multiple'
		req = urllib.request.Request(url)
		r = urllib.request.urlopen(req).read()
		data = json.loads(r.decode('utf-8-sig'))

		#Cargo desde generadores
		#data = json.loads(generaPreguntasPrimaria())
		
		while (nRespuesta < NResponse):
			# Limpia la pantalla y establece su color de fondo
			pantalla.fill(cBLANCO)
			# Muestra la pantalla de fondo de la pregunta:
			imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_231_RESPUESTASLARGAS_ingles.png").convert()
			pantalla.blit(imagen, posicion_base)
			
			# Escribe la pregunta
			#print ('PREGUNTA NÚMERO ' + str(nRespuesta+1) + ': ' + data['results'][nRespuesta]['question'])
			fuente = pygame.font.SysFont('/home/pi/QuizzPi/Antonio-Bold.ttf', 36)

			txtPregunta = 'PREGUNTA ' + str(nRespuesta+1)
			#render(texto,1,color)
			mensaje = fuente.render(txtPregunta, 1, cAZUL)
			pantalla.blit(mensaje, (40, 10))

			fuente = pygame.font.SysFont('/home/pi/QuizzPy/Antonio-Light.ttf', 28)
			txtPregunta = data['results'][nRespuesta]['question'].replace('"','\\"').replace("'","\\'").replace("&shy;",'').replace("&quot;",'"').replace('&#039;',"'")
			if len(txtPregunta)<=45:
				txtLinea1 = txtPregunta
				mensaje = fuente.render(txtPregunta, 1, cAZUL)
				pantalla.blit(mensaje, (40, 55))
			elif len(txtPregunta)<=90:
				txtLinea1 = txtPregunta[:45]
				txtLinea2 = txtPregunta[45:]
				mensaje = fuente.render(txtLinea1, 1, cAZUL)
				pantalla.blit(mensaje, (40, 47))
				mensaje = fuente.render(txtLinea2, 1, cAZUL)
				pantalla.blit(mensaje, (40, 73))
			else:
				txtLinea1 = txtPregunta[:45]
				txtLinea2 = txtPregunta[45:]
				txtLinea3 = txtLinea2[45:]
				txtLinea2 = txtLinea2[:45]
				mensaje = fuente.render(txtLinea1, 1, cAZUL)
				pantalla.blit(mensaje, (40, 47))
				mensaje = fuente.render(txtLinea2, 1, cAZUL)
				pantalla.blit(mensaje, (40, 66))
				mensaje = fuente.render(txtLinea3, 1, cAZUL)
				pantalla.blit(mensaje, (40, 85))

			randomnumber = randint(0, 3)
			i = 0
			nr = 0;
			respuesta = "";
			while (i < 4):
				if (i == randomnumber):
					txtRespuesta = data['results'][nRespuesta]['correct_answer'].replace('"','\\"').replace("'","\\'").replace('&shy;','').replace('&quot;','"').replace('&#039;',"'")
					# Escribe la respuesta
					fuente = pygame.font.SysFont('/home/pi/QuizzPi/Antonio-Bold.ttf', 28)
					mensaje = fuente.render(txtRespuesta, 1, cAZUL)
					pantalla.blit(mensaje, (142, 129+i*50))
				else:
					txtRespuesta = data['results'][nRespuesta]['incorrect_answers'][nr].replace('"','\\"').replace("'","\\'").replace('&shy;','').replace('&quot;','"').replace('&#039;',"'")
					# Escribe la respuesta
					fuente = pygame.font.SysFont('/home/pi/QuizzPi/Antonio-Bold.ttf', 28)
					mensaje = fuente.render(txtRespuesta, 1, cAZUL)
					pantalla.blit(mensaje, (142, 129+i*50))
					nr = nr + 1
				i = i + 1

			# Limitamos a 60 fotogramas por segundo.
			reloj.tick(20)
 
			# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
			pygame.display.flip()

			pygame.mixer.music.load(sound_beep)
			pygame.mixer.music.play(0)
	
			# Esperamos pulsacion de boton
			btnPulsado = -1
			qResponse = ' '
			seguirEnBucle = True
			while (seguirEnBucle):
				if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO 
					btnPulsado = -1
					qResponse = '0'
					seguirEnBucle = False
				if (btnPulsado == btnAmarillo):		# El usuario pulsa el BOTON AMARILLO 
					btnPulsado = -1
					qResponse = '1'
					seguirEnBucle = False
				if (btnPulsado == btnVerde):		# El usuario pulsa el BOTON VERDE
					btnPulsado = -1
					qResponse = '2'
					seguirEnBucle = False
				if (btnPulsado == btnAzul):			# El usuario pulsa el BOTON AZUL
					btnPulsado = -1
					qResponse = '3'
					seguirEnBucle = False

				#Actualizo reloj
				instanteFinal = datetime.now()
				tiempo = instanteFinal - instanteInicial
				segundos = tiempo.seconds
				pygame.draw.rect(pantalla,cBLANCO,(280,0,479,50))
				fuente = pygame.font.Font('/home/pi/QuizzPi/Antonio-Regular.ttf', 18)
				txtPregunta = 'Tiempo: ' + str(segundos) + ' segundos'
				mensaje = fuente.render(txtPregunta, 1, cNEGRO)
				pantalla.blit(mensaje, (380-mensaje.get_rect().width/2, 20))

				# Limitamos a 60 fotogramas por segundo.
				reloj.tick(20)
 
				# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
				pygame.display.flip()

			if (qResponse != str(randomnumber)):
				# Limpia la pantalla y establece su color de fondo
				pantalla.fill(cBLANCO)

				# Muestra la pantalla de ERROR:
				imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_26_ERROR_ingles.png").convert()
				pantalla.blit(imagen, posicion_base)

				# Limitamos a 60 fotogramas por segundo.
				reloj.tick(20)
 
				# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
				pygame.display.flip()
				
				pygame.mixer.music.load(sound_error)
				pygame.mixer.music.play(0)
	
				# Esperamos 3 segundos
				time.sleep(3)
			else:
				# Limpia la pantalla y establece su color de fondo
				pantalla.fill(cBLANCO)
 
				# Muestra la pantalla CORRECTO:
				imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_25_CORRECTO_ingles.png").convert()

				pantalla.blit(imagen, posicion_base)

				# Limitamos a 60 fotogramas por segundo.
				reloj.tick(20)
 
				# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
				pygame.display.flip()
				
				pygame.mixer.music.load(sound_acierto)
				pygame.mixer.music.play(0)
			
				# Esperamos 3 segundos
				time.sleep(3)
				score = score + 1
				
			instanteFinal = datetime.now()
			tiempo = instanteFinal - instanteInicial
			segundos = tiempo.seconds
			
			# Mostramos los resultados parciales
			#print ('Llevas acertadas ' + str(score) + ' de ' + str(nRespuesta+1)+' en ' + str(segundos) + ' segundos.\n')
			nRespuesta = nRespuesta + 1
			
		instanteFinal = datetime.now()
		tiempo = instanteFinal - instanteInicial
		segundos = tiempo.seconds
		minu=int(segundos/60)
		seg=segundos-minu*60
		
		# Mostramos los resultados finales
		#print ('Tu resultado final es ' + str(score) + ' acertadas de ' + str(NResponse) + ' en un tiempo de ' + str(minu) + ':' + str(seg) + '.\n')

		# Borrar pantalla
		pantalla.fill(cBLANCO)

		# Muestra la pantalla de fondo de la pregunta:
		imagen = pygame.image.load("/home/pi/QuizzPi/quiz_pantalla_24_RESULTADOS_ingles.png").convert()
		pantalla.blit(imagen, posicion_base)
			
		#Escribe el texto
		fuente = pygame.font.SysFont('arial', 32)
		txtResultados = strNombre
		mensaje = fuente.render(txtResultados, 1, cAZUL)
		pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 70))
		
		fuente = pygame.font.Font('/home/pi/QuizzPi/Antonio-Bold.ttf', 36)
		if (score >=10):
			txtResultados = '¡ PERFECT !'
		elif (score >=7):
			txtResultados = '¡ VERY GOOD !'
		elif (score >=5):
			txtResultados = '¡ NOT BAD !'
		elif (score >=3):
			txtResultados = '¡ BAD !'
		elif (score < 3):
			txtResultados = '¡ DISASTROUS !'
		else:
			txtResultados = '¡ ERROR !'
		mensaje = fuente.render(txtResultados, 1, cAZUL)
		pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 115))
		
		fuente = pygame.font.Font('/home/pi/QuizzPi/Antonio-Bold.ttf', 24)
		txtResultados = 'You have succesfully answered ' + str(score) + ' of ' + str(NResponse) + ' questions'
		mensaje = fuente.render(txtResultados, 1, cAZUL)
		pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 185))
		txtResultados = 'with a time of ' + str(segundos) + ' seconds.'
		mensaje = fuente.render(txtResultados, 1, cAZUL)
		pantalla.blit(mensaje, (240-mensaje.get_rect().width/2, 215))

		# Añadimos a los mejores y nos quedamos con los 10 primeros
		# Recuperamos el fichero de mejores
		high_scores = {}
		if (os.path.exists('/home/pi/QuizzPi/losmejores.txt')) and (os.path.getsize('/home/pi/QuizzPi/losmejores.txt')>0):
			high_scores = json.load(open('/home/pi/QuizzPi/losmejores.txt'))
		else:
			high_scores = {}

		if len(high_scores) == 0:
			#Fichero estaba vacio, rellenamos high_scores con el resultado
			array_scores = []
		else:
			array_scores = high_scores["lista"]
		array_scores.append((strNombre,score,NResponse,segundos,score*100/NResponse,segundos/score))
		array_scores = sorted(sorted(sorted(array_scores, key=itemgetter(3), reverse=False), key=itemgetter(2), reverse=True), key=itemgetter(4), reverse=True)[:10]
		nuevo_high_scores = {}
		nuevo_high_scores["lista"] = array_scores

		with open('/home/pi/QuizzPi/losmejores.txt', 'w') as outfile:
			json.dump(nuevo_high_scores, outfile)		
		
		# Limitamos a 60 fotogramas por segundo.
		reloj.tick(20)

		# Avancemos y actualicemos la pantalla con lo que hemos dibujado.
		pygame.display.flip()
				
		pygame.mixer.music.load(sound_antesde)
		pygame.mixer.music.play(0)
		pygame.mixer.music.load(sound_resultados)
		pygame.mixer.music.play(0)
	
		# Esperamos pulsacion de boton
		btnPulsado = -1
		seguirEnBucle = True;
		while (seguirEnBucle):
			if (btnPulsado == btnRojo):			# El usuario pulsa el BOTON ROJO 
				btnPulsado = -1
				fase_actual = f_MEJORES
				seguirEnBucle = False;
		
# Pórtate bien con el IDLE. Si nos olvidamos de esta línea, el programa se 'colgará'
# en la salida.
pygame.quit()
